package com.sr3uncheat;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.nio.channels.FileChannel;
import java.util.Locale;

import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.UIManager;
import javax.swing.UIManager.LookAndFeelInfo;

/**
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * 
 * @author qwer <hellraz0r.386@googlemail.com>
 */
public class Main
{
	public static final long		cheatByteOffset	= 0xC8;
	
	/**
	 * Hi Qwer,
	 * 
	 * I've noticed that your Savegame Cheat Disabler checks for game saves in pirated game locations - do you own SR:TT
	 * legally, and would it be possible for you to remove these checks? We don't support pirated copies of SR:TT here.
	 * 
	 * Minimaul, 2012-01-07 at 10:14 AM
	 */
	/*getEnv("LOCALAPPDATA") + "\\SKIDROW\\55230\\Storage",
	getEnv("USERPROFILE") + "\\Local Settings\\Application Data\\SKIDROW\\55230\\Storage",*/
	public static final String[]	searchPaths		= new String[] { getEnv("ProgramFiles") + "\\Steam\\userdata",
			getEnv("ProgramFiles(x86)") + "\\Steam\\userdata" };
	
	public static void main(final String[] args)
	{
		if (args.length > 0 && args[0] != "")
		{
			final StringBuilder stringBuilder = new StringBuilder();
			for (final String arg : args)
			{
				stringBuilder.append(arg);
				stringBuilder.append(" ");
			}
			
			final File file = new File(stringBuilder.toString());
			try
			{
				uncheatSavegame(file);
			}
			catch (final UserMessage message)
			{
				System.err.println(message);
				System.exit(1);
			}
			System.out.println(UserMessage.cheatsDisabled);
			System.exit(0);
		}
		else
		{
			final JFrame frame = new JFrame("SR 3 Uncheater");
			frame.setUndecorated(true);
			frame.setVisible(true);
			frame.setBounds(400, 400, 0, 0);
			
			activateNimbusTheme();
			UIManager.put("FileChooser.readOnly", Boolean.TRUE);
			
			Locale.setDefault(Locale.ENGLISH);
			JComponent.setDefaultLocale(Locale.ENGLISH);
			
			File directory = new File(".");
			for (final String path : searchPaths)
			{
				final File newDirectory = new File(path);
				if (newDirectory.isDirectory())
				{
					directory = newDirectory;
					break;
				}
			}
			
			final JFileChooser fileChooser = new JFileChooser();
			fileChooser.addChoosableFileFilter(new SavegameFileFilter());
			fileChooser.setAcceptAllFileFilterUsed(false);
			fileChooser.setDialogTitle("SR 3 Uncheater: choose savegame");
			fileChooser.setCurrentDirectory(directory);
			
			boolean retry = true;
			while (retry)
			{
				retry = false;
				
				final int result = fileChooser.showOpenDialog(frame);
				if (result == JFileChooser.APPROVE_OPTION)
				{
					try
					{
						uncheatSavegame(fileChooser.getSelectedFile());
					}
					catch (final UserMessage message)
					{
						retry = message.retry;
						JOptionPane.showMessageDialog(frame, message.message, "Error", JOptionPane.ERROR_MESSAGE);
						if (!retry)
						{
							System.exit(1);
						}
					}
					if (!retry)
					{
						JOptionPane.showMessageDialog(frame, UserMessage.cheatsDisabled, "Success",
								JOptionPane.INFORMATION_MESSAGE);
						System.exit(0);
					}
				}
			}
			System.exit(2);
		}
	}
	
	public static void uncheatSavegame(final File file) throws UserMessage
	{
		RandomAccessFile fileAccess = null;
		try
		{
			fileAccess = new RandomAccessFile(file, "rw");
			
			if (fileAccess.length() < cheatByteOffset + 1) { throw new UserMessage(UserMessage.fileTypeInvalid
					+ " flen"); }
			
			fileAccess.seek(Main.cheatByteOffset);
			final int read = fileAccess.read();
			if (read == -1)
			{
				throw new UserMessage(UserMessage.diskIOSeekError);
			}
			else if (read == 0)
			{
				throw new UserMessage(UserMessage.cheatsAlreadyDisabled, true);
			}
			else if (read != 1) { throw new UserMessage(UserMessage.fileTypeInvalid); }
			
			backupFile(file);
			fileAccess.seek(Main.cheatByteOffset);
			fileAccess.write(0);
		}
		catch (final FileNotFoundException e)
		{
			System.out.print(e.getMessage());
			if (e.getMessage().contains("being used by another process")) { throw new UserMessage(
					UserMessage.fileInUse, true); }
			throw new UserMessage(UserMessage.fileNotFound);
		}
		catch (final IOException e)
		{
			e.printStackTrace();
			throw new UserMessage(UserMessage.diskIOError + e.getMessage());
		}
		finally
		{
			if (fileAccess != null)
			{
				try
				{
					fileAccess.close();
				}
				catch (final IOException e)
				{
				}
			}
		}
	}
	
	public static void backupFile(final File file) throws UserMessage
	{
		final File destinationFile = new File(file.getParentFile(), file.getName() + ".bak");
		
		FileChannel source = null;
		FileChannel destination = null;
		
		try
		{
			source = new FileInputStream(file).getChannel();
			destination = new FileOutputStream(destinationFile).getChannel();
			destination.transferFrom(source, 0, source.size());
		}
		catch (final IOException e)
		{
			throw new UserMessage(UserMessage.fileBackupError);
		}
		finally
		{
			if (source != null)
			{
				try
				{
					source.close();
				}
				catch (final IOException e)
				{
				}
			}
			if (destination != null)
			{
				try
				{
					destination.close();
				}
				catch (final IOException e)
				{
				}
			}
		}
	}
	
	public static boolean activateNimbusTheme()
	{
		try
		{
			for (final LookAndFeelInfo info : UIManager.getInstalledLookAndFeels())
			{
				if ("Nimbus".equals(info.getName()))
				{
					UIManager.setLookAndFeel(info.getClassName());
					return true;
				}
			}
		}
		catch (final Exception e)
		{
		}
		return false;
	}
	
	public static String getEnv(final String name)
	{
		final String value = System.getenv(name);
		if (value == null) { return "%" + name + "%"; }
		return value;
	}
}
