package com.sr3uncheat;

/**
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * 
 * @author qwer <hellraz0r.386@googlemail.com>
 */
public class UserMessage extends Throwable
{
	private static final long	serialVersionUID		= 7325848869223352783L;
	
	public static final String	fileNotFound			= "File not found.";
	public static final String	fileInUse				= "The file is already in use by another program.";
	public static final String	fileTypeInvalid			= "The file does not appear to be a valid SR 3 PC savegame.";
	public static final String	fileBackupError			= "Unable to backup file.";
	
	public static final String	diskIOError				= "Disk I/O error: ";
	public static final String	diskIOSeekError			= diskIOError
																+ "Unable to seek file position";
	
	public static final String	cheatsDisabled			= "Cheats disabled successfully.";
	public static final String	cheatsAlreadyDisabled	= "This savegame does not have Cheats enabled.";
	
	public final String			message;
	public final boolean		retry;
	
	public UserMessage(final String message)
	{
		this(message, false);
	}
	
	public UserMessage(final String message, final boolean retry)
	{
		this.message = message;
		this.retry = retry;
	}
	
	@Override
	public String toString()
	{
		return message;
	}
}
